import tensorflow as tf

flags = tf.app.flags
FLAGS = flags.FLAGS
def mynet(input, reuse=False):
    with tf.name_scope("model"):
        with tf.variable_scope("conv1"):
            net = tf.layers.conv1d(input, filters=2, kernel_size=3, strides=2, activation=tf.nn.sigmoid,
                                   padding='SAME', reuse=reuse, )
            net = tf.layers.max_pooling1d(net, pool_size=3, strides=2, padding='SAME')
        net = tf.contrib.layers.flatten(net)
        return net

def contrastive_loss(model1, model2, y, margin):
    with tf.name_scope("contrastive-loss"):
        d = tf.sqrt(tf.reduce_sum(tf.pow(model1-model2, 2), 1, keep_dims=True))
        a = tf.abs(tf.subtract(d, margin*y))
        return tf.reduce_mean(a)