import tensorflow as tf
import numpy as np
from dataset import BatchGenerator,get_data
from scipy import stats
from sklearn import svm
from model import *
import sklearn
from sklearn import metrics
from public.elm import ELMClassifier
np.seterr(divide='ignore', invalid='ignore')

# construct features and TRank
def constructed(filename):
	# 载入数据集
	data, label = get_data(filename)
	k = len(data[0])
	data = np.array([im.reshape((k, 1)) for im in data])
	img_placeholder = tf.placeholder(tf.float32, [None, k, 1], name='test_data')
	net = mynet(img_placeholder, reuse=True)

	# P,N index------
	P_index = np.argwhere(label == 1).ravel()
	N_index = np.argwhere(label == 0).ravel()

	# run the test data through the network to get the test features
	saver = tf.train.Saver()
	with tf.Session() as sess:
		sess.run(tf.global_variables_initializer())
		ckpt = tf.train.get_checkpoint_state("model")
		saver.restore(sess, "temp_model/model.ckpt")
		search_feat = sess.run(net, feed_dict={img_placeholder: data})
	sess = tf.Session()
	k_new = len(search_feat[0])  # 构造后的特征个数
	# print(k_new)
	# P,N data for new------
	P_data = np.zeros((k_new, len(P_index)))
	N_data = np.zeros((k_new, len(N_index)))
	for i in range(k_new):
		for j in range(len(P_index)):
			P_data[i][j] = search_feat[P_index[j]][i]
	for i in range(k_new):
		for j in range(len(N_index)):
			N_data[i][j] = search_feat[N_index[j]][i]
	# ----------------

	# ttest for new-----------
	Pvalue = np.zeros(k_new)
	for i in range(k_new):
		if stats.levene(P_data[i], N_data[i])[1] > 0.05:
			w = stats.ttest_ind(P_data[i], N_data[i], equal_var=True)
		else:
			w = stats.ttest_ind(P_data[i], N_data[i], equal_var=False)
		Pvalue[i] = w[1]

	k_index = Pvalue.argsort()
	Pvalue.sort()
	final_data = np.zeros((len(label), k_new))
	for i in range(len(label)):
		for j in range(k_new):
			final_data[i][j] = search_feat[i][k_index[j]]
	return final_data,label

# IFS + ELM
def Accuracy(filename):
	data,label = constructed(filename)
	acc = 0
	num = 0
	# IFS + ELM
	for i in range(len(data[0])):
		aa = np.zeros((len(label), i + 1))
		for m in range(len(label)):
			for n in range(i + 1):
				aa[m][n] = data[m][n]
		clf = ELMClassifier()
		predict = sklearn.model_selection.cross_val_predict(clf, X=aa, y=label, cv=3)
		temp = metrics.accuracy_score(predict, label)
		if acc < temp:
			acc = temp
			num = i+1
			predict = sklearn.model_selection.cross_val_predict(clf, X=aa, y=label, cv=3)
			C1 = metrics.confusion_matrix(label, predict)
			C = C1.ravel()  # TN,FP,FN,TP
			Sn = metrics.recall_score(label,predict)
			Sp = C[0]/(C[0]+C[1])

	return acc,Sn,Sp,num
